diff -ruN ../nakedmudv3.7/src/handler.c src/handler.c
--- ../nakedmudv3.7/src/handler.c	2008-12-06 00:20:20.000000000 -0500
+++ src/handler.c	2009-03-02 01:00:32.000000000 -0500
@@ -30,7 +30,7 @@
 #include "items/container.h"
 #include "items/worn.h"
 #include "scripts/scripts.h"
-#include "scripts/pymud.h"
+#include "scripts/pymudsys.h"
 
 
 
@@ -85,9 +85,16 @@
 }
 
 void obj_to_game(OBJ_DATA *obj) {
+  if(setIn(object_set, obj))
+    return;
+
+  // property table, for lookup by python
   if(!obj_exists(obj))
     obj_exist(obj);
+
+  // set and list storage, for objects physically 'in' the game
   listPut(object_list, obj);
+  setPut(object_set, obj);
 
   // execute all of our to_game hooks
   hookRun("obj_to_game", hookBuildInfo("obj", obj));
@@ -169,8 +176,13 @@
 }
 
 void room_to_game(ROOM_DATA *room) {
+  if(setIn(room_set, room))
+    return;
+
   if(!room_exists(room))
     room_exist(room);
+
+  setPut(room_set, room);
   listPut(room_list, room);
 
   // execute all of our to_game hooks
@@ -200,13 +212,23 @@
   char           *dir = NULL;
   ITERATE_LIST(dir, ex_i) {
     exit_to_game(roomGetExit(room, dir));
-    if(get_cmd_move() != NULL && dirGetNum(dir) == DIR_NONE) {
-      CMD_DATA *old_cmd = nearMapRemove(roomGetCmdTable(room), dir);
-      CMD_DATA     *cmd = newPyCmd(dir, get_cmd_move(), "player", TRUE);
-      if(old_cmd != NULL)
-	deleteCmd(old_cmd);
-      cmdAddCheck(cmd, chk_can_move);
-      nearMapPut(roomGetCmdTable(room), dir, NULL, cmd);
+    // if we already have a command for this direction in place, ignore
+    if(roomHasCmd(room, dir))
+      continue;
+    // if it is a special exit and we have a registered movement command,
+    // add a special command to the room to use this exit
+    else if(dirGetNum(dir) == DIR_NONE && get_cmd_move() != NULL) {
+      CMD_DATA *cmd = newPyCmd(dir, get_cmd_move(), "player", TRUE);
+
+      // add all of our movement checks
+      LIST_ITERATOR *chk_i = newListIterator(get_move_checks());
+      PyObject        *chk = NULL;
+      ITERATE_LIST(chk, chk_i) {
+	cmdAddPyCheck(cmd, chk);
+      } deleteListIterator(chk_i);
+
+      //cmdAddCheck(cmd, chk_can_move);
+      roomAddCmd(room, dir, NULL, cmd);
     }
   } deleteListIterator(ex_i);
   deleteListWith(ex_list, free);
@@ -266,8 +288,13 @@
 }
 
 void char_to_game(CHAR_DATA *ch) {
+  if(setIn(mobile_set, ch))
+    return;
+
   if(!char_exists(ch))
     char_exist(ch);
+  
+  setPut(mobile_set, ch);
   listPut(mobile_list, ch);
 
   // execute all of our to_game hooks
@@ -311,7 +338,8 @@
     deleteListIterator(cont_i);
   }
 
-  listRemove(object_list, obj);
+  if(setRemove(object_set, obj))
+    listRemove(object_list, obj);
   propertyTableRemove(obj_table, objGetUID(obj));
 }
 
@@ -346,7 +374,8 @@
   deleteListIterator(ex_i);
   deleteListWith(ex_list, free);
 
-  listRemove(room_list, room);
+  if(setRemove(room_set, room))
+    listRemove(room_list, room);
   propertyTableRemove(room_table, roomGetUID(room));
 }
 
@@ -374,58 +403,72 @@
   }
   deleteList(eq);
 
-  listRemove(mobile_list, ch);
+  if(setRemove(mobile_set, ch))
+    listRemove(mobile_list, ch);
   propertyTableRemove(mob_table, charGetUID(ch));
 }
 
 void obj_from_char(OBJ_DATA *obj) {
   if(objGetCarrier(obj)) {
+    CHAR_DATA *ch = objGetCarrier(obj);
     listRemove(charGetInventory(objGetCarrier(obj)), obj);
     objSetCarrier(obj, NULL);
+    hookRun("obj_from_char", hookBuildInfo("obj ch", obj, ch));
   }
 }
 
 void obj_from_obj(OBJ_DATA *obj) {
   if(objGetContainer(obj)) {
+    OBJ_DATA *container = objGetContainer(obj);
     listRemove(objGetContents(objGetContainer(obj)), obj);
     objSetContainer(obj, NULL);
+    hookRun("obj_from_obj", hookBuildInfo("obj obj", obj, container));
   }
 }
 
 void obj_from_room(OBJ_DATA *obj) {
   if(objGetRoom(obj)) {
+    ROOM_DATA *room = objGetRoom(obj);
     listRemove(roomGetContents(objGetRoom(obj)), obj);
     objSetRoom(obj, NULL);
+    hookRun("obj_from_room", hookBuildInfo("obj rm", obj, room));
   }
 }
 
 void obj_to_char(OBJ_DATA *obj, CHAR_DATA *ch) {
   listPut(charGetInventory(ch), obj);
   objSetCarrier(obj, ch);
+  hookRun("obj_to_char", hookBuildInfo("obj ch", obj, ch));
 }
 
 void obj_to_obj(OBJ_DATA *obj, OBJ_DATA *to) {
   listPut(objGetContents(to), obj);
   objSetContainer(obj, to);
+  hookRun("obj_to_obj", hookBuildInfo("obj obj", obj, to));
 }
 
 void obj_to_room(OBJ_DATA *obj, ROOM_DATA *room) {
   listPut(roomGetContents(room), obj);
   objSetRoom(obj, room);
+  hookRun("obj_to_room", hookBuildInfo("obj rm", obj, room));
 }
 
 void char_from_room(CHAR_DATA *ch) {
-  charSetLastRoom(ch, charGetRoom(ch));
-  roomRemoveChar(charGetRoom(ch), ch);
-  charSetRoom(ch, NULL);
+  if(charGetRoom(ch) != NULL) {
+    ROOM_DATA *room = charGetRoom(ch);
+    hookRun("char_from_room", hookBuildInfo("ch rm", ch, room));
+    charSetLastRoom(ch, charGetRoom(ch));
+    roomRemoveChar(charGetRoom(ch), ch);
+    charSetRoom(ch, NULL);
+  }
 }
 
 void char_to_room(CHAR_DATA *ch, ROOM_DATA *room) {
   if(charGetRoom(ch))
     char_from_room(ch);
-
   roomAddChar(room, ch);
   charSetRoom(ch, room);
+  hookRun("char_to_room", hookBuildInfo("ch rm", ch, room));
 }
 
 void char_from_furniture(CHAR_DATA *ch) {
@@ -877,6 +920,7 @@
     if(count >= at_count) {
       if(found_type)
 	*found_type = FOUND_OBJ;
+
       OBJ_DATA *obj = find_obj(looker, equipment, at_count, at, NULL, 
 			       (IS_SET(find_scope, FIND_SCOPE_VISIBLE)));
       deleteList(equipment);
@@ -1068,6 +1112,29 @@
   char working_arg[SMALL_BUFFER];
   strcpy(working_arg, arg);
 
+  char *at = NULL;
+  char *in = NULL;
+  char *on = NULL;
+
+  // are we trying to look "at" something or "on" something?
+  if(!parse_args(looker,FALSE,"",working_arg,
+		 "[at] [the] word | <on> [the] word",&at,&on)) {
+    // try again with "in"
+    strcpy(working_arg, arg);
+    if(!parse_args(looker,FALSE,"",working_arg,
+		   "[at] [the] word | <in> [the] word",&at,&in)) {
+      // try one last time using the whole argument
+      strcpy(working_arg, arg);
+      if(!parse_args(looker,FALSE,"",working_arg,
+		     "[at] [the] string", &at)) {
+	at = NULL;
+	in = NULL;
+	on = NULL;
+      }
+    }
+  }
+
+  /*
   strip_word(working_arg, "the");
 
   char *at = at_arg(working_arg);
@@ -1091,12 +1158,13 @@
     at = strtok(working_arg, " ");
     at = strdupsafe(at);
   }
+  */
 
   // make sure at, in, and on are never NULL
   // we always want to search by name, and never vnum
-  if(!at) at = strdup("");
-  if(!on) on = strdup("");
-  if(!in) in = strdup("");
+  at = strdupsafe(at);
+  on = strdupsafe(on);
+  in = strdupsafe(in);
 
   // do the finding
   void *val = find_specific(looker, 
@@ -1142,7 +1210,6 @@
   if(found_type)
     *found_type = FOUND_NONE;
 
-
   // are we trying to find all of something?
   if(all_ok && at_count == COUNT_ALL && !*on && !*in)
     return find_all(looker, at, find_types, find_scope, found_type);
diff -ruN ../nakedmudv3.7/src/hashtable.c src/hashtable.c
--- ../nakedmudv3.7/src/hashtable.c	2008-05-31 00:17:59.000000000 -0400
+++ src/hashtable.c	2009-03-02 01:00:32.000000000 -0500
@@ -12,12 +12,16 @@
 #include <string.h>
 #include "list.h"
 #include "hashtable.h"
+#include "mud.h"
+#include "utils.h"
+
+
 
 // how big of a size do our hashtables start out at?
 #define DEFAULT_HASH_SIZE        5
 
 struct hashtable_iterator {
-  int curr_bucket;
+  unsigned int curr_bucket;
   HASHTABLE *table;
   LIST_ITERATOR *bucket_i;
 };
@@ -35,29 +39,9 @@
 
 
 //
-// this is a fairly simple hashing function. It could do 
-// with some major speeding up.
-int hash(const char *key) {
-  const int BASE = 2;
-  int base = 1;
-  int hvalue = 0;
-
-  for (; *key; key++) {
-    base *= BASE;
-    if(!isalpha(*key))
-      hvalue += *key * base;
-    else
-      hvalue += tolower(*key) * base;
-  }
-
-  return (hvalue < 0 ? hvalue * -1 : hvalue);
-}
-
-
-//
 // an internal form of hashGet that returns the entire entry (key and val)
 HASH_ENTRY *hashGetEntry(HASHTABLE *table, const char *key){
-  int bucket = hash(key) % table->num_buckets;
+  unsigned int bucket = string_hash(key) % table->num_buckets;
 
   if(table->buckets[bucket] == NULL)
     return NULL;
@@ -86,7 +70,6 @@
   free(entry);
 }
 
-
 //
 // Collect all of the HASH_ENTRYs in a hashtable into a single list
 LIST *hashCollectEntries(HASHTABLE *table) {
@@ -136,6 +119,10 @@
   free(table);
 }
 
+void deleteHashtableWith(HASHTABLE *table, void *func) {
+  hashClearWith(table, func);
+  deleteHashtable(table);
+}
 
 //
 // expand a hashtable to the new size
@@ -158,7 +145,7 @@
 
   // now, we put all of our entries back into the new buckets
   while((entry = listPop(entries)) != NULL) {
-    int bucket = hash(entry->key) % table->num_buckets;
+    unsigned int bucket = string_hash(entry->key) % table->num_buckets;
     if(table->buckets[bucket] == NULL) table->buckets[bucket] = newList();
     listPut(table->buckets[bucket], entry);
   }
@@ -166,7 +153,7 @@
 }
 
 
-int  hashPut    (HASHTABLE *table, const char *key, void *val) {
+int hashPut(HASHTABLE *table, const char *key, void *val) {
   HASH_ENTRY *elem = hashGetEntry(table, key);
 
   // if it's already in, update the value
@@ -179,7 +166,7 @@
     if((table->size * 80)/100 > table->num_buckets)
       hashExpand(table, (table->num_buckets * 150)/100);
 
-    int bucket = hash(key) % table->num_buckets;
+    unsigned int bucket = string_hash(key) % table->num_buckets;
 
     // if the bucket doesn't exist yet, create it
     if(table->buckets[bucket] == NULL)
@@ -192,7 +179,7 @@
   }
 }
 
-void *hashGet    (HASHTABLE *table, const char *key) {
+void *hashGet(HASHTABLE *table, const char *key) {
   HASH_ENTRY *elem = hashGetEntry(table, key);
   if(elem != NULL)
     return elem->val;
@@ -200,8 +187,8 @@
     return NULL;
 }
 
-void *hashRemove (HASHTABLE *table, const char *key) {
-  int bucket = hash(key) % table->num_buckets;
+void *hashRemove(HASHTABLE *table, const char *key) {
+  unsigned int bucket = string_hash(key) % table->num_buckets;
 
   if(table->buckets[bucket] == NULL)
     return NULL;
diff -ruN ../nakedmudv3.7/src/hashtable.h src/hashtable.h
--- ../nakedmudv3.7/src/hashtable.h	2008-05-31 00:17:59.000000000 -0400
+++ src/hashtable.h	2009-03-02 01:00:32.000000000 -0500
@@ -20,7 +20,15 @@
 // create a new hashtable. the default number of buckets are used
 HASHTABLE *newHashtable(void);
 
-void  deleteHashtable(HASHTABLE *table);
+//
+// delete the hashtable. Nothing is done to its contents. Table must be cleared
+// before being deleted to prevent memory leaks
+void deleteHashtable(HASHTABLE *table);
+
+//
+// Deletes the hashtable, and also deletes all of its contents with the
+// given function. Should take the form: void func(void *data)
+void deleteHashtableWith(HASHTABLE *table, void *function);
 
 int   hashPut    (HASHTABLE *table, const char *key, void *val);
 void *hashGet    (HASHTABLE *table, const char *key);
diff -ruN ../nakedmudv3.7/src/help2/hedit.c src/help2/hedit.c
--- ../nakedmudv3.7/src/help2/hedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/help2/hedit.c	2009-03-02 01:00:32.000000000 -0500
@@ -183,6 +183,6 @@
 //*****************************************************************************
 void init_hedit() {
   // add our commands
-  add_cmd("hedit",   NULL, cmd_hedit,   "admin", FALSE);
-  add_cmd("hdelete", NULL, cmd_hdelete, "admin", FALSE); 
+  add_cmd("hedit",   NULL, cmd_hedit,   "builder", FALSE);
+  add_cmd("hdelete", NULL, cmd_hdelete, "builder", FALSE); 
 }
diff -ruN ../nakedmudv3.7/src/help2/help.c src/help2/help.c
--- ../nakedmudv3.7/src/help2/help.c	2008-05-31 00:38:22.000000000 -0400
+++ src/help2/help.c	2009-03-02 01:00:32.000000000 -0500
@@ -94,6 +94,19 @@
 }
 
 //
+// returns a list of all help keywords
+LIST *get_all_help(void) {
+  LIST             *all = newList();
+  NEAR_ITERATOR *help_i = newNearIterator(help_table);
+  const char      *name = NULL;
+  HELP_DATA       *data = NULL;
+  ITERATE_NEARMAP(name, data, help_i) {
+    listQueue(all, strdup(name));
+  } deleteNearIterator(help_i);
+  return all;
+}
+
+//
 // returns where the help file would be stored on disc if it exists
 const char *get_help_file(const char *keyword) {
   static BUFFER *buf = NULL;
@@ -115,6 +128,9 @@
 COMMAND(cmd_help) {
   char       *kwd = NULL;
   HELP_DATA *data = NULL;
+  if(*arg == '\'' || *arg == '"')
+    one_arg(arg, arg);
+
   if(!parse_args(ch, TRUE, cmd, arg, "| string", &kwd))
     return;
 
@@ -188,7 +204,7 @@
   else {
     BUFFER     *buf = newBuffer(1);
     char      header[128]; // +2 for \r\n, +1 for \0
-    center_string(header, data->keywords, 80, 128, TRUE);
+    center_string(header, data->keywords, 79, 128, TRUE);
 
     // build the header and the info
     bprintf(buf, "%s{n%s", header, data->info);
@@ -211,7 +227,9 @@
   char            *kwd = NULL;
   ITERATE_LIST(kwd, kwd_i) {
     // remove any old copy we might of had
-    nearMapRemove(help_table, kwd);
+    HELP_DATA *old = nearMapRemove(help_table, kwd);
+    if(old != NULL)
+      deleteHelp(old);
     
     // put our new entry
     nearMapPut(help_table, kwd, NULL, data);
@@ -222,6 +240,7 @@
     STORAGE_SET *set = helpStore(data);
     char    *primary = listGet(kwds, 0); 
     storage_write(set, get_help_file(primary));
+    storage_close(set);
   }
 
   // garbage collection
@@ -281,7 +300,7 @@
 
 
 //*****************************************************************************
-// python hooks
+// python extensions
 //*****************************************************************************
 PyObject *PyMudSys_add_help(PyObject *self, PyObject *args) {
   char *keywords    = NULL;
@@ -298,6 +317,53 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *PyMudSys_get_help(PyObject *self, PyObject *args) {
+  char     *name = NULL;
+  bool abbrev_ok = FALSE;
+
+  if(!PyArg_ParseTuple(args, "s|b", &name, &abbrev_ok)) {
+    PyErr_Format(PyExc_TypeError, "Invalid arguments supplied to get_help");
+    return NULL;
+  }
+
+  // find the helpfile we're looking for
+  HELP_DATA *help = get_help(name, abbrev_ok);
+  
+  // did we find it?
+  if(help == NULL)
+    return Py_BuildValue("OOOO", Py_None, Py_None, Py_None, Py_None);
+  else
+    return Py_BuildValue("ssss",
+			 helpGetKeywords(help),
+			 helpGetInfo(help),
+			 helpGetUserGroups(help),
+			 helpGetRelated(help));
+}
+
+PyObject *PyMudSys_list_help(PyObject *self, PyObject *args) {
+  char  *keyword = NULL;
+
+  if(!PyArg_ParseTuple(args, "|s", &keyword)) {
+    PyErr_Format(PyExc_TypeError, "Invalid arguments supplied to get_help");
+    return NULL;
+  }
+
+  // find our matches; all topics if there is no keyword
+  LIST *matches = (keyword ? get_help_matches(keyword) : get_all_help());
+
+  // get_help_matches likes to return NULL if it doesn't find anything.
+  // kind of annoying.
+  if(matches == NULL) 
+    matches = newList();
+
+  // convert the list of string to Python strings
+  PyObject *pymatches = PyList_fromList(matches, PyString_FromString);
+
+  // garbage collection
+  deleteListWith(matches, free);
+  return Py_BuildValue("O", pymatches);
+}
+
 
 
 //*****************************************************************************
@@ -353,17 +419,6 @@
     STORAGE_SET       *set = storage_read(OLD_HELP_FILE);
     STORAGE_SET_LIST *list = read_list(set, "helpfiles");
     STORAGE_SET     *entry = NULL;
-    BUFFER         *dirbuf = newBuffer(1);
-
-    // make all of our new directories
-    mkdir(HELP_DIR, S_IRWXU | S_IRWXG);
-    char subdir = '\0';
-    for(subdir = 'A'; subdir <= 'Z'; subdir++) {
-      bufferClear(dirbuf);
-      bprintf(dirbuf, "%s/%c", HELP_DIR, subdir);
-      mkdir(bufferString(dirbuf), S_IRWXU | S_IRWXG);
-    }
-    deleteBuffer(dirbuf);
 
     // parse all of the helpfiles
     while( (entry = storage_list_next(list)) != NULL)
@@ -399,4 +454,8 @@
   // add all of our Python hooks
   PyMudSys_addMethod("add_help", PyMudSys_add_help, METH_VARARGS, 
 		     "allows Python modules to add non-persistent helpfiles.");
+  PyMudSys_addMethod("get_help", PyMudSys_get_help, METH_VARARGS, 
+		     "returns info for the help file.");
+  PyMudSys_addMethod("list_help", PyMudSys_list_help, METH_VARARGS,
+		     "Returns all help topics. If a partial keyword is supplied, only return partial matches.");
 }
diff -ruN ../nakedmudv3.7/src/hooks.c src/hooks.c
--- ../nakedmudv3.7/src/hooks.c	2008-05-31 00:17:59.000000000 -0400
+++ src/hooks.c	2009-03-02 01:00:32.000000000 -0500
@@ -87,7 +87,7 @@
   LIST_ITERATOR *mon_i = newListIterator(monitors);
   void (* mon)(const char *, const char *) = NULL;
   ITERATE_LIST(mon, mon_i) {
-    mon(type, info);
+    mon(type, info_dup);
   } deleteListIterator(mon_i);
   free(info_dup);
 }
diff -ruN ../nakedmudv3.7/src/hooks.h src/hooks.h
--- ../nakedmudv3.7/src/hooks.h	2008-05-31 00:17:59.000000000 -0400
+++ src/hooks.h	2009-03-02 01:00:32.000000000 -0500
@@ -22,7 +22,10 @@
 
 //
 // random character we use for denoting the beginning/end of a string
-#define HOOK_STR_MARKER '\033'
+//
+// THIS NEEDS TO BE CHANGED TO SOMETHING LESS INSIDIOUS! If we're building
+// strings with escape sequences, this could be deadly.
+#define HOOK_STR_MARKER '\032'
 
 //
 // prepare hooks for use
diff -ruN ../nakedmudv3.7/src/inform.c src/inform.c
--- ../nakedmudv3.7/src/inform.c	2008-12-06 00:20:20.000000000 -0500
+++ src/inform.c	2009-03-02 01:05:38.000000000 -0500
@@ -46,14 +46,14 @@
   listRemove(can_see, ch);
 
   char *chars = print_list(can_see, charGetName, charGetMultiName);
-  if(*chars) send_to_char(ch, "{g%s %s %s %s%s.\r\n",
+  if(*chars) send_to_char(ch, "{n%s %s %s %s%s.\r\n",
 			  chars, (listSize(can_see) == 1 ? "is" : "are"),
 			  (furnitureGetType(furniture)==FURNITURE_AT?"at":"on"),
 			  objGetName(furniture),
 			  (charGetFurniture(ch) == furniture ?" with you": ""));
   // everyone was invisible to us... we should still show the furniture though
   else
-    send_to_char(ch, "{g%s\r\n", objGetRdesc(furniture));
+    send_to_char(ch, "{n%s\r\n", objGetRdesc(furniture));
   deleteList(can_see);
   free(chars);
 }
@@ -140,15 +140,15 @@
   hookRun("append_obj_desc", hookBuildInfo("obj ch", obj, ch));
 
   // colorize all of the edescs
-  edescTagDesc(charGetLookBuffer(ch), objGetEdescs(obj), "{c", "{g");
+  edescTagDesc(charGetLookBuffer(ch), objGetEdescs(obj), "{c", "{n");
 
   // format the desc, and send it
   bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
   if(bufferLength(charGetLookBuffer(ch)) == 0)
-    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+    send_to_char(ch, "{n%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
+    send_to_char(ch, "{n%s", bufferString(charGetLookBuffer(ch)));
 
   hookRun("look_at_obj", hookBuildInfo("obj ch", obj, ch));
   send_to_char(ch, "{n");
@@ -168,16 +168,16 @@
 
   // colorize all of the edescs
   edescTagDesc(charGetLookBuffer(ch), roomGetEdescs(exitGetRoom(exit)), 
-	       "{c", "{g");
+	       "{c", "{n");
 
   // format our description
   bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
   // if the buffer has nothing in it, send a "nothing special" message
   if(bufferLength(charGetLookBuffer(ch)) == 0)
-    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+    send_to_char(ch, "{n%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
+    send_to_char(ch, "{n%s", bufferString(charGetLookBuffer(ch)));
 
   hookRun("look_at_exit", hookBuildInfo("ex ch", exit, ch));
   send_to_char(ch, "{n");
@@ -187,12 +187,12 @@
 // shows a single exit to a character
 void list_one_exit(CHAR_DATA *ch, EXIT_DATA *exit, const char *dir) {
   char   buf[100] = "\0"; // for the room class
-  ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(exit));
+  ROOM_DATA *dest = worldGetRoom(gameworld, exitGetToFull(exit));
 
   if(bitIsOneSet(charGetUserGroups(ch), "builder"))
-    sprintf(buf, "[%s] ", roomGetClass(dest));
+    snprintf(buf, 100, " [%s]", roomGetClass(dest));
 
-  send_to_char(ch, "{g  %-10s :: %s%s\r\n", dir, buf, 
+  send_to_char(ch, "{n  %-10s :: %s%s\r\n", dir, buf, 
 	       (exitIsClosed(exit) ? 
 		// if it's closed, print the exit name
 		(*exitGetName(exit) ? exitGetName(exit) : "closed" ) :
@@ -213,7 +213,7 @@
   for(i = 0; i < NUM_DIRS; i++) {
     if( (exit = roomGetExit(room, dirGetName(i))) != NULL) {
       // make sure the destination exists
-      if( (to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL)
+      if( (to = worldGetRoom(gameworld, exitGetToFull(exit))) == NULL)
 	log_string("ERROR: room %s heads %s to room %s, which does not exist.",
 		   roomGetClass(room), dirGetName(i), exitGetTo(exit));
       else if(can_see_exit(ch, exit))
@@ -226,7 +226,7 @@
     if(dirGetNum(dir) == DIR_NONE) {
       exit = roomGetExit(room, dir);
       // make sure the destination exists
-      if( (to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL)
+      if( (to = worldGetRoom(gameworld, exitGetToFull(exit))) == NULL)
 	log_string("ERROR: room %s heads %s to room %s, which does not exist.",
 		   roomGetClass(room), dir, exitGetTo(exit));
       else if(can_see_exit(ch, exit))
@@ -251,10 +251,10 @@
   bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
   if(bufferLength(charGetLookBuffer(ch)) == 0)
-    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+    send_to_char(ch, "{n%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s{n", bufferString(charGetLookBuffer(ch)));
-  
+    send_to_char(ch, "{n%s{n", bufferString(charGetLookBuffer(ch)));
+
   hookRun("look_at_char", hookBuildInfo("ch ch", vict, ch));
 }
 
@@ -269,6 +269,7 @@
   // make the working copy of the description, and fill it up with info
   bufferClear(charGetLookBuffer(ch));
   bufferCat(charGetLookBuffer(ch), roomGetDesc(room));
+
   // do all of our preprocessing of the description before we show it
   hookRun("preprocess_room_desc", hookBuildInfo("rm ch", room, ch));
 
@@ -276,15 +277,18 @@
   hookRun("append_room_desc", hookBuildInfo("rm ch", room, ch));
 
   // colorize all of the edescs
-  edescTagDesc(charGetLookBuffer(ch), roomGetEdescs(room), "{c", "{g");
+  edescTagDesc(charGetLookBuffer(ch), roomGetEdescs(room), "{c", "{n");
 
   // format our description
   bufferFormat(charGetLookBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
+  // do any post-processing we might have
+  hookRun("postprocess_room_desc", hookBuildInfo("rm ch", room, ch));
+
   if(bufferLength(charGetLookBuffer(ch)) == 0)
-    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+    send_to_char(ch, "{n%s\r\n", NOTHING_SPECIAL);
   else
-    send_to_char(ch, "{g%s", bufferString(charGetLookBuffer(ch)));
+    send_to_char(ch, "{n%s", bufferString(charGetLookBuffer(ch)));
 
   hookRun("look_at_room", hookBuildInfo("rm ch", room, ch));
   send_to_char(ch, "{n");
@@ -475,9 +479,9 @@
     else if(found_type == FOUND_EDESC) {
       EDESC_SET *set = edescGetSet(found);
       BUFFER  *edesc = bufferCopy(edescGetDescBuffer(found));
-      edescTagDesc(edesc, set, "{c", "{g");
+      edescTagDesc(edesc, set, "{c", "{n");
       bufferFormat(edesc, SCREEN_WIDTH, PARA_INDENT);
-      send_to_char(ch, "{g%s", bufferString(edesc));
+      send_to_char(ch, "%s", bufferString(edesc));
       deleteBuffer(edesc);
     }
 
@@ -496,6 +500,7 @@
     // couldn't find anything. too bad!
     else
       send_to_char(ch, "What did you want to at?\r\n");
+
   }
 }
 
@@ -539,8 +544,9 @@
 		  const char *str,
 		  CHAR_DATA *ch, CHAR_DATA *vict,
 		  OBJ_DATA *obj, OBJ_DATA *vobj) {
-  char buf[MAX_BUFFER];
+  static char buf[MAX_BUFFER];
   int i, j;
+  *buf = '\0';
 
   // if there's nothing to send the message to, don't go through all
   // the work it takes to parse the string
@@ -628,7 +634,7 @@
   }
 
   //  buf[0] = toupper(buf[0]);
-  sprintf(buf+j, "\r\n");
+  sprintf(buf+j, "{n\r\n");
   text_to_char(to, buf);
 }
 
@@ -657,7 +663,7 @@
   // check if the scope of this message is everyone in the world
   if(IS_SET(range, TO_WORLD))
     recipients = mobile_list;
-  else if(IS_SET(range, TO_ROOM))
+  else if(IS_SET(range, TO_ROOM) && charGetRoom(ch) != NULL)
     recipients = roomGetCharacters(charGetRoom(ch));
 
   // if we have a list to send the message to, do it
@@ -718,7 +724,7 @@
   // or different-room-name destinations.
   ITERATE_LIST(ex, ex_i) {
     EXIT_DATA *exit = roomGetExit(room, ex);
-    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(exit));
+    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetToFull(exit));
     if(dest && can_see_exit(ch, exit) && dirGetNum(ex) != DIR_NONE) {
       if(exitIsClosed(exit))
 	listPut(ex_closed, ex);
@@ -741,7 +747,7 @@
   // append info for dirs that exit to other room names
   ex_i = newListIterator(ex_diff);
   ITERATE_LIST(ex, ex_i) {
-    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(roomGetExit(room, ex)));
+    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetToFull(roomGetExit(room, ex)));
     bprintf(buf, " Continuing %s would take you to %s.", ex, roomGetName(dest));
   } deleteListIterator(ex_i);
 
@@ -776,7 +782,7 @@
 
   BUFFER         *buf = charGetLookBuffer(ch);
   ROOM_DATA     *room = exitGetRoom(exit);
-  ROOM_DATA     *dest = worldGetRoom(gameworld, exitGetTo(exit));
+  ROOM_DATA     *dest = worldGetRoom(gameworld, exitGetToFull(exit));
   LIST       *exnames = roomGetExitNames(room);
   LIST_ITERATOR *ex_i = newListIterator(exnames);
   char            *ex = NULL;
@@ -818,7 +824,7 @@
   hookParseInfo(info, &exit, &ch);
   // the door is not closed, list off the people we can see as well
   if(!exitIsClosed(exit)) {
-    ROOM_DATA *room = worldGetRoom(gameworld, exitGetTo(exit));
+    ROOM_DATA *room = worldGetRoom(gameworld, exitGetToFull(exit));
     if(room != NULL)
       list_room_contents(ch, room);
   }
@@ -842,6 +848,6 @@
   hookAdd("append_exit_desc", exit_append_hook);
   // enable if you want exits to append to the end of room descs
   //  hookAdd("append_room_desc", exit_append_room_hook);
-  hookAdd("look_at_exit", exit_look_hook);
-  hookAdd("look_at_room", room_look_hook);
+  //  hookAdd("look_at_exit", exit_look_hook);
+  //  hookAdd("look_at_room", room_look_hook);
 }
